/**
 * 
 */
package eu.etaxonomy.taxeditor.navigation.key.polytomous;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * @author n.hoffmann
 *
 */
public class PolytomousKeyContentProvider implements IStructuredContentProvider{

	@Override
	public void dispose() {
		
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
		
	}

	@Override
	public Object[] getElements(Object inputElement) {
		if(inputElement instanceof List){
			
			Collections.sort((List)inputElement,new PolytomousKeyComparator());
			return ((List) inputElement).toArray();
		}
		return null;
	}
	
	public class PolytomousKeyComparator implements Comparator<Object> {

		@Override
		public int compare(Object o1, Object o2) {
			if(o1 == null && o2 == null) {
				return 0;
			} else if (o1 == null) {
				return -1;
			} else if(o2 == null) {
				return +1;
			} else {
				return o1.toString().compareTo(o2.toString());
			}
		}
		
	}

}
