/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.key.polytomous.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.runtime.Status;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.taxeditor.navigation.NavigationUtil;
import eu.etaxonomy.taxeditor.navigation.key.polytomous.PolytomousKeyViewPart;
import eu.etaxonomy.taxeditor.newWizard.NewPolytomousKeyWizard;

/**
 * <p>NewTaxonNodeHandler class.</p>
 *
 * @author n.hoffmann
 * @created Sep 15, 2009
 * @version 1.0
 */
public class NewPolytomousKeyHandler extends AbstractHandler implements IHandler {

    /* (non-Javadoc)
     * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
     */
    /** {@inheritDoc} */
    public Object execute(ExecutionEvent event) throws ExecutionException {
        NewPolytomousKeyWizard wizard = new NewPolytomousKeyWizard();
        wizard.init(null,null);
        WizardDialog dialog = new WizardDialog(HandlerUtil.getActiveShell(event), wizard);
        int status = dialog.open();    
        if(status == Status.OK) {            
            PolytomousKeyViewPart view = (PolytomousKeyViewPart) NavigationUtil.getView(PolytomousKeyViewPart.ID, false);            
            //List<PolytomousKey> pklist = CdmStore.getService(IPolytomousKeyService.class).list(PolytomousKey.class, null, null, null, null);            
            view.refresh();            
            view.setViewerSelection(new StructuredSelection(wizard.getEntity()),true);           
            view.openSelectedKeyNodes();            
        }
        return null;
    }
}
