package eu.etaxonomy.taxeditor.navigation.navigator;

import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.internal.navigator.NavigatorContentService;
import org.eclipse.ui.internal.navigator.dnd.NavigatorDnDService;
import org.eclipse.ui.navigator.CommonDragAdapter;
import org.eclipse.ui.navigator.CommonDropAdapter;
import org.eclipse.ui.navigator.CommonViewer;
import org.eclipse.ui.navigator.INavigatorContentService;

import eu.etaxonomy.taxeditor.dnd.transfer.TaxonNodeTransfer;

public class TaxonNavigatorViewer extends CommonViewer {

	private NavigatorContentService contentService;
	String viewerId;

	public TaxonNavigatorViewer(String aViewerId, Composite aParent, int aStyle) {
		super(aViewerId, aParent, aStyle);
		contentService = new TaxonNavigatorContentService(aViewerId, this);
		viewerId = aViewerId;
	}

	@Override
	protected void initDragAndDrop() {

		int operations =  DND.DROP_MOVE ;

		CommonDragAdapter dragAdapter = createDragAdapter();
		addDragSupport(operations, dragAdapter.getSupportedDragTransfers(),
				dragAdapter);
		Transfer[] transfers = new Transfer[] { TaxonNodeTransfer.getInstance() };
		TreeNodeDropAdapter dropAdapter = createTreeNodeDropAdapter();
		addDropSupport(operations, transfers, dropAdapter);

		TaxonNavigatorDnDService dnd = (TaxonNavigatorDnDService)getNavigatorContentService().getDnDService();
		dnd.setDropAdaptor(dropAdapter);
	}
	
	
	protected TreeNodeDropAdapter createTreeNodeDropAdapter() {
		return new TreeNodeDropAdapter(this);
	}
	
	public NavigatorContentService getNavigatorContentService(){
		if (contentService == null){
			contentService = new TaxonNavigatorContentService(viewerId);
		} 
		return contentService;
	}
	
}
