/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.navigation.navigator;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.dnd.DragSourceAdapter;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.ui.navigator.CommonViewer;


import eu.etaxonomy.cdm.model.common.DefinedTermBase;
import eu.etaxonomy.cdm.model.taxon.ITaxonTreeNode;
import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.dnd.transfer.TaxonNodeTransfer;
import eu.etaxonomy.taxeditor.editor.definedterm.TermTransfer;

/**
 * @author k.luther
 * @date 02.06.2015
 *
 */
public class TreeNodeDragListener extends DragSourceAdapter {
	private CommonViewer viewer;

	/**
	 * 
	 */
	public TreeNodeDragListener(CommonViewer viewer) {
		this.viewer = viewer;
	}

	
	public void setViewer(CommonViewer viewer){
		this.viewer = viewer;
	}
	/* (non-Javadoc)
	 * @see org.eclipse.swt.dnd.DragSourceAdapter#dragStart(org.eclipse.swt.dnd.DragSourceEvent)
	 */
	@Override
	public void dragStart(DragSourceEvent event) {
		
		event.doit = true;// set to false if needed - default is true
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.dnd.DragSourceAdapter#dragFinished(org.eclipse.swt.dnd.DragSourceEvent)
	 */
	@Override
	public void dragFinished(DragSourceEvent event) {
		// TODO Auto-generated method stub
		super.dragFinished(event);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.dnd.DragSourceAdapter#dragSetData(org.eclipse.swt.dnd.DragSourceEvent)
	 */
	@Override
	public void dragSetData(DragSourceEvent event) {
		
		IStructuredSelection selection = (IStructuredSelection) viewer.getSelection();
		List<ITaxonTreeNode> taxonNodes = new ArrayList<ITaxonTreeNode>();
		
		for (Object object : selection.toList()){
			taxonNodes.add((ITaxonTreeNode)object);
			}
			
		if (TaxonNodeTransfer.getInstance().isSupportedType(
				event.dataType)) {
			event.data = taxonNodes.toArray(new TaxonNode[taxonNodes.size()]);
		}
	}
}
