/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.navigator.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.taxeditor.navigation.navigator.TaxonNavigator;

/**
 * <p>RefreshTreeHandler class.</p>
 *
 * @author p.ciardelli
 * @created 04.09.2009
 * @version 1.0
 */
public class RefreshTreeHandler extends AbstractHandler {
	private static final Logger logger = Logger
			.getLogger(RefreshTreeHandler.class);

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	/** {@inheritDoc} */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		
		IWorkbenchPart part = HandlerUtil.getActivePart(event);
		if (part instanceof TaxonNavigator) {
			((TaxonNavigator) part).refresh();
		}
		return null;
	}
}
