package eu.etaxonomy.taxeditor.navigation.navigator.handler;

import java.util.UUID;

import org.eclipse.core.commands.AbstractParameterValueConverter;
import org.eclipse.core.commands.ParameterValueConversionException;

import eu.etaxonomy.cdm.api.service.ITaxonService;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class TaxonParameterConverter extends AbstractParameterValueConverter {

    public TaxonParameterConverter() {
    }

    @Override
    public Object convertToObject(String parameterValue) throws ParameterValueConversionException {
        return CdmStore.getService(ITaxonService.class).load(UUID.fromString(parameterValue));
    }

    @Override
    public String convertToString(Object parameterValue) throws ParameterValueConversionException {
        if(parameterValue instanceof TaxonBase<?>){
            return ((TaxonBase) parameterValue).getUuid().toString();
        }
        return null;
    }

}
