/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.navigation.navigator.operation;

import java.util.UUID;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.api.application.CdmChangeEvent.Action;
import eu.etaxonomy.cdm.api.service.IDescriptionService;
import eu.etaxonomy.cdm.api.service.UpdateResult;
import eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation;

/**
 * @author cmathew
 * @date 19 Jun 2015
 *
 */
public class RemotingMoveFactualDataOperation extends RemotingCdmUpdateOperation {

    private final static String LABEL = "Move Factual Data operation";

    private final UUID sourceTaxonUuid;
    private final UUID targetParentTaxonUuid;

    /**
     * @param label
     * @param action
     * @param source
     * @param async
     */
    public RemotingMoveFactualDataOperation(Object source,
            boolean async,
            UUID sourceTaxonUuid,
            UUID targetParentTaxonUuid) {
        super(LABEL, Action.Update, source, async);
        this.sourceTaxonUuid = sourceTaxonUuid;
        this.targetParentTaxonUuid = targetParentTaxonUuid;
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmUpdateOperation#doUpdateExecute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
     */
    @Override
    protected UpdateResult doUpdateExecute(IProgressMonitor monitor, IAdaptable info) throws Exception {
        return CdmApplicationState.getService(IDescriptionService.class).moveTaxonDescriptions(sourceTaxonUuid,
                targetParentTaxonUuid);
    }

}
